﻿$.level = 2;

const mm = 72/25.4


  markWeight = 0.25
  markLength = 5 *mm
  markOffset = 0 *mm
  regLength = 10 *mm
  
offsetStr = "Offset reg marx";


if ( documents.length > 0 )
{
	doc = activeDocument;
	
	var regColor = new SpotColor();
	regColor.spot = doc.spots['[Registration]'];	
	
	origin = doc.rulerOrigin;
	var start = true;
	
	var privod_crest = new File( "/D/Паша/shablon/priv_crest.eps");
	if (doc.width >= 500 * mm){
    var scale = new File( "/D/Паша/shablon/scale_a2.eps");}
    else var scale = new File( "/D/Паша/shablon/scale_a3.eps");
    var clr = new File( "/D/Паша/shablon/color.pdf");
	
	var obj = doc.selection[0];

	if( regOffset = prompt(offsetStr,"0")) {
    regOffset = regOffset * mm;
	if(doc.selection instanceof Array && doc.selection.length == 1) {
		
	var bnd = getBounds(obj);	
	W = bnd[2]-bnd[0];
	H = bnd[1]-bnd[3];
	x1 = bnd[0];
	x2 = bnd[2];
	y1 = bnd[1];
	y2 = bnd[3];
	var mLayer= doc.layers.add();    	 
	mLayer.name = 'regmarx';    	
	var embedDoc = new File( privod_crest);
    if ( embedDoc.exists ) {    	 	 
         var placed = doc.groupItems.createFromFile( embedDoc );
         var w1 = placed.width;
     var h1 = placed.height;
     line(mLayer,x1 - regOffset, y1, x1 - regLength - regOffset, y1, regColor, 0.25);
     line(mLayer,x2 + regOffset, y1, x2 + regLength + regOffset, y1, regColor, 0.25);
     if (doc.width >= 500 * mm){
     line(mLayer,(x2 - x1) / 2 + x1, y1 + regOffset, (x2 - x1) / 2 + x1, y1 + regOffset + regLength, regColor, 0.25);
     }
     x = x1 - w1;
     y = y2 + h1;
     H = (y1 - y2) / 2 + y2 + h1 / 2;     
     placed.position = Array(x - regOffset, y1);
     placed.duplicate();
     placed.position = Array(x2 + regOffset, y1);
     placed.duplicate(); 
     placed.position = Array(x - regOffset, y);
     placed.duplicate();
     placed.position = Array(x2 + regOffset, y);
     placed.duplicate();
     placed.position = Array(x - regOffset, H);
     placed.duplicate();
     placed.position = Array(x2 + regOffset, H);            
          }
     
     var embedDoc = new File( clr);
     if ( embedDoc.exists ) {    	 	 
         var placed = doc.groupItems.createFromFile( embedDoc );
         w1 = placed.width;
     h2 = placed.height;
     placed.position = Array(x1 - regOffset - w1, y2 + h1 + h2);
	 var embedDoc = new File( scale);            
          }
     
     if ( embedDoc.exists ) {    	 	 
         var placed = doc.groupItems.createFromFile( embedDoc );
         w1 = placed.width;
     h1 = placed.height;
     W = (W - w1) /2 + x1;
     placed.position = Array(W, y2 - regOffset);                  
          }
     mLayer.zOrder(ZOrderMethod.SENDTOBACK);
          
}
}
function line(parent,x1,y1,x2,y2,color,weight) 
{
	var line = parent.pathItems.add();
	line.stroked = true;
	line.filled = false;
	line.strokeWidth = weight;
	line.strokeColor = color;
	line.setEntirePath( Array( Array(x1, y1), Array(x2, y2) ) );
	line = null;
}

function regMark(parent,x,y,r,color,weight)
{
	rm = parent.groupItems.add();
	var r2 = r/2;
	line(rm, x, y-r2, x, y+r2, color, weight);
	line(rm, x-r2, y, x+r2, y, color, weight);
	var ellipse = rm.pathItems.ellipse( y+r2, x-r2, r, r);
	ellipse.stroked = true;
	ellipse.filled = false;
	ellipse.strokeWidth = weight;
	ellipse.strokeColor = color;
	rm = null;
}

function getBounds(obj) {
	var vbounds = new Array();

	if( (obj.typename == 'GroupItem') && !obj.clipped ) {
		vbounds = getBounds(obj.pageItems[0]);
		for( n=1; n<obj.pageItems.length; n++  ) {
			vgb = getBounds(obj.pageItems[n]);
			if( vbounds[0] > vgb[0] ) vbounds[0] = vgb[0];
			if( vbounds[1] < vgb[1] ) vbounds[1] = vgb[1];
			if( vbounds[2] < vgb[2] ) vbounds[2] = vgb[2];
			if( vbounds[3] > vgb[3] ) vbounds[3] = vgb[3];
		}
	}
	else if( (obj.typename == 'GroupItem') && obj.clipped && (obj.pageItems.length > 1) ) {
		vbounds = getBounds(obj.pageItems[0]);
		
		cvgb = getBounds(obj.pageItems[1]);
		objleft = cvgb[0];
		objtop = cvgb[1];
		objright = cvgb[2];
		objbottom = cvgb[3];
		
		obj.pageItems[0].stroked ? so = 0 : so = 1;
		for( n=so; n<obj.pageItems.length; n++ ) {
			cvgb = getBounds(obj.pageItems[n]);
			if( objleft > cvgb[0] ) objleft = cvgb[0];
			if( objtop < cvgb[1] ) objtop = cvgb[1];
			if( objright < (cvgb[2]) ) objright = cvgb[2];
			if( objbottom > (cvgb[3]) ) objbottom = cvgb[3];
		}
		if( vbounds[0] < objleft ) vbounds[0] = objleft;
		if( vbounds[1] > objtop ) vbounds[1] = objtop;
		if( vbounds[2] > objright ) vbounds[2] = objright;
		if( vbounds[3] < objbottom ) vbounds[3] = objbottom;
	}
	else {
		vbounds = obj.visibleBounds;
	}

	return vbounds;
}
}
